
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <locale.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include <sys/time.h>
#include "gtkxentrymask.h"

void
on_testgtkxentrymaskwindow_destroy      (GtkObject       *object,
                                        gpointer         user_data)
{
  exit(0);
}


void
on_txtdate_focus_out_event( GtkObject *object,
			    gpointer apointer)
{
  time_t adate;

  adate = gtkx_entrymask_get_time_t(GTKX_ENTRYMASK(object));
}

void
on_txttime_focus_out_event( GtkObject *object,
			    gpointer apointer)
{
  time_t atime;
  atime = gtkx_entrymask_get_time_t(GTKX_ENTRYMASK(object));
}

void
on_txtdatetime_focus_out_event( GtkObject *object,
				gpointer apointer)
{
  time_t adate;

  adate = gtkx_entrymask_get_time_t(GTKX_ENTRYMASK(object));
}

GtkWidget*
create_testgtkxentrymaskwindow (void)
{
  GtkWidget *testgtkxentrymaskwindow;
  GtkWidget *vbox1;
  GtkWidget *table1;
  GtkWidget *lblNoMask;
  GtkWidget *lblNumeric;
  GtkWidget *lblCurrency;
  GtkWidget *lblDate;
  GtkWidget *lblTime;
  GtkWidget *lblDateTime;
  GtkWidget *lblIP;
  GtkWidget *lblTelephone;
  GtkWidget *txtwithoutmask;
  GtkWidget *txtnumeric;
  GtkWidget *txtcurrency;
  GtkWidget *txtdate;
  GtkWidget *txttime;
  GtkWidget *txtdatetime;
  GtkWidget *txtip;
  GtkWidget *txttelephone;

  testgtkxentrymaskwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (testgtkxentrymaskwindow), "testgtkxentrymaskwindow", testgtkxentrymaskwindow);
  gtk_window_set_title (GTK_WINDOW (testgtkxentrymaskwindow), "Test gtkxentrymask");
  gtk_window_set_position (GTK_WINDOW (testgtkxentrymaskwindow), GTK_WIN_POS_CENTER);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (testgtkxentrymaskwindow), vbox1);

  table1 = gtk_table_new (10, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox1), table1, TRUE, TRUE, 0);

  lblNoMask = gtk_label_new ("Without mask");
  gtk_widget_ref (lblNoMask);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "lblNoMask", lblNoMask,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lblNoMask);
  gtk_table_attach (GTK_TABLE (table1), lblNoMask, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  lblNumeric = gtk_label_new ("Numeric");
  gtk_widget_ref (lblNumeric);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "lblNumeric", lblNumeric,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lblNumeric);
  gtk_table_attach (GTK_TABLE (table1), lblNumeric, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  lblCurrency = gtk_label_new ("Currency");
  gtk_widget_ref (lblCurrency);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "lblCurrency", lblCurrency,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lblCurrency);
  gtk_table_attach (GTK_TABLE (table1), lblCurrency, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  lblDate = gtk_label_new ("Date");
  gtk_widget_ref (lblDate);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "lblDate", lblDate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lblDate);
  gtk_table_attach (GTK_TABLE (table1), lblDate, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  lblTime = gtk_label_new ("Time");
  gtk_widget_ref (lblTime);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "lblTime", lblTime,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lblTime);
  gtk_table_attach (GTK_TABLE (table1), lblTime, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  lblDateTime = gtk_label_new ("Datetime");
  gtk_widget_ref (lblDateTime);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "lblDateTime", lblDateTime,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lblDateTime);
  gtk_table_attach (GTK_TABLE (table1), lblDateTime, 0, 1, 5, 6,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  lblIP = gtk_label_new ("IP");
  gtk_widget_ref (lblIP);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "lblIP", lblIP,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lblIP);
  gtk_table_attach (GTK_TABLE (table1), lblIP, 0, 1, 6, 7,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  lblTelephone = gtk_label_new ("Telephone");
  gtk_widget_ref (lblTelephone);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "lblTelephone", lblTelephone,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lblTelephone);
  gtk_table_attach (GTK_TABLE (table1), lblTelephone, 0, 1, 7, 8,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  txtwithoutmask = gtk_entry_new ();
  gtk_widget_ref (txtwithoutmask);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "txtwithoutmask", txtwithoutmask,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txtwithoutmask);
  gtk_table_attach (GTK_TABLE (table1), txtwithoutmask, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  txtnumeric = gtkx_entrymask_new_with_type (ENTRYMASK_NUMERIC, NULL, NULL);
  gtk_widget_ref (txtnumeric);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "txtnumeric", txtnumeric,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txtnumeric);
  gtk_table_attach (GTK_TABLE (table1), txtnumeric, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  txtcurrency = gtkx_entrymask_new_with_type (ENTRYMASK_CURRENCY, "B", NULL);
  gtk_widget_ref (txtcurrency);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "txtcurrency", txtcurrency,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txtcurrency);
  gtk_table_attach (GTK_TABLE (table1), txtcurrency, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  txtdate = gtkx_entrymask_new_with_type (ENTRYMASK_DATE, "%x", NULL);
  gtk_widget_ref (txtdate);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "txtdate", txtdate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txtdate);
  gtk_table_attach (GTK_TABLE (table1), txtdate, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  txttime = gtkx_entrymask_new_with_type (ENTRYMASK_TIME, "%T", NULL);
  gtk_widget_ref (txttime);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "txttime", txttime,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txttime);
  gtk_table_attach (GTK_TABLE (table1), txttime, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  txtdatetime = gtkx_entrymask_new_with_type (ENTRYMASK_DATETIME, "%c", NULL);
  gtk_widget_ref (txtdatetime);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "txtdatetime", txtdatetime,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txtdatetime);
  gtk_table_attach (GTK_TABLE (table1), txtdatetime, 1, 2, 5, 6,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  txtip = gtkx_entrymask_new_with_type (ENTRYMASK_STRING, NULL, "000.000.000.000");
  gtk_widget_ref (txtip);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "txtip", txtip,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txtip);
  gtk_table_attach (GTK_TABLE (table1), txtip, 1, 2, 6, 7,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  txttelephone = gtkx_entrymask_new_with_type (ENTRYMASK_STRING, NULL, "+>< (\\999)99-99-99");
  gtk_widget_ref (txttelephone);
  gtk_object_set_data_full (GTK_OBJECT (testgtkxentrymaskwindow), "txttelephone", txttelephone,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txttelephone);
  gtk_table_attach (GTK_TABLE (table1), txttelephone, 1, 2, 7, 8,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  gtk_signal_connect (GTK_OBJECT (testgtkxentrymaskwindow), "destroy",
                      GTK_SIGNAL_FUNC (on_testgtkxentrymaskwindow_destroy),
                      NULL);

  {
    gtkx_entrymask_set_time_t(GTKX_ENTRYMASK(txtdate), time(NULL));
    gtkx_entrymask_set_time_t(GTKX_ENTRYMASK(txttime), time(NULL));
    gtkx_entrymask_set_time_t(GTKX_ENTRYMASK(txtdatetime), time(NULL));
    gtkx_entrymask_set_double(GTKX_ENTRYMASK(txtnumeric), 3333.33);
    gtkx_entrymask_set_double(GTKX_ENTRYMASK(txtcurrency), 1234.23);
    gtk_signal_connect (GTK_OBJECT (txtdate), "focus_out_event",
			GTK_SIGNAL_FUNC (on_txtdate_focus_out_event),
			NULL);
    gtk_signal_connect (GTK_OBJECT (txttime), "focus_out_event",
			GTK_SIGNAL_FUNC (on_txttime_focus_out_event),
			NULL);
    gtk_signal_connect (GTK_OBJECT (txtdatetime), "focus_out_event",
			GTK_SIGNAL_FUNC (on_txtdatetime_focus_out_event),
			NULL);
  }

  return testgtkxentrymaskwindow;
}



int
main (int argc, char *argv[])
{
  GtkWidget *testgtkxentrymaskwindow;

  /* locales: es_ES, en_US, en_CA, de_DE, fr_FR */
  g_print("Locale set to:%s\n", setlocale(LC_ALL, ""));
  gtk_init(&argc,&argv);

  testgtkxentrymaskwindow = create_testgtkxentrymaskwindow ();
  gtk_widget_show (testgtkxentrymaskwindow);

  gtk_main ();
  return 0;
}


